(*
 *  beware IRC services, authcommands.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and peter green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit authcommands;

interface
  uses
    buser,
    accountUSINGbot,
    bstuff,
    accountcore,
    objbot,
    accountmanagecmds,
    botmanagecommands,
    logincmds,
    infocmds,
    binipstuff,
    bvaliddef;


procedure priv_hello(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_requestpassword(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_nickkill(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_ghost(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_listipthrottle(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
procedure priv_delipthrottle(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
const
  botmaxcmd=31;

var
// %nick% in the info or syntax field is replaced with the bots nick
// %server% in the info or syntax field is replaced with the services servers name
// %cmd% in the info or syntax field is replaced with the name of the command
// %newline% in the info or syntax field signifies a new line  note : USING this in
// the info field will really screw up the formatting of the help reply it is
// really intended for the syntax field

cmdtab:array[0..botmaxcmd] of tcmdtab=(

(
cmd:'LOGIN';
level:-1;
p:priv_login;
minparams:3;
info:'Logs you in to your account';
syntax:'type /msg %nick%@%server% %cmd% <username> <password>'),
(
cmd:'HELLO';
level:-1;
p:priv_hello;
minparams:4;
info:'Creates a new account';
syntax:'type /msg %nick% %cmd% <an account name> <password> <repeat password>'),
(
cmd:'HELP';
level:-1;
p:priv_showcommands;
minparams:1;
info:'Displays this list of commands, and get more help about a command';
syntax:'type /msg %nick% %cmd% [<command>]'),
(
cmd:'REQUESTPASSWORD';
level:-1;
p:priv_requestpassword;
minparams:2;
info:'For when you have lost your password';
syntax:'type /msg %nick% %cmd% <your email address>'),
(
cmd:'NICKKILL';
level:0;
p:priv_nickkill;
minparams:1;
info:'Kills a connection using your nick';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'NEWPASS';
level:0;
p:priv_newpass;
minparams:4;
info:'Changes your existing password to a new one';
syntax:'type /msg %nick% %cmd% <oldpass> <newpass> <newpass>'),
(
cmd:'DROP';
level:0;
p:priv_drop;
minparams:3;
info:'Deletes your %nick% account';
syntax:'type /msg %nick% %cmd% <myusername> <mypassword>'),
(
cmd:'MKPASSWD';
level:10;
p:priv_mkpasswd;
minparams:2;
info:'Encrypts a password.';
syntax:'type /msg %nick% %cmd% <password>'),
(
cmd:'USERLIST';
level:100;
p:priv_USERlist;
minparams:1;
info:'Lists user accounts. (parameters minlevel maxlevel)';
syntax:'type /msg %nick% cmd% [<minlevel> [<maxlevel>]]'),
(
cmd:'USERINFO';
level:100;
p:priv_USERinfo;
minparams:2;
info:'Displays information about an account.';
syntax:'type /msg %nick% %cmd% <username>'),

(
cmd:'ADDUSER';
level:800;
p:priv_addUSER;
minparams:3;
info:'Creates a new user account.';
syntax:'type /msg %nick% %cmd% <username> <level>'),
(
cmd:'DELUSER';
level:800;
p:priv_delUSER;
minparams:2;
info:'Deletes an existing account.';
syntax:'type /msg %nick% %cmd% <username>'),
(
cmd:'MODUSER';
level:800;
p:priv_modUSER;
minparams:3;
info:'Modify''s a users account';
syntax:'type /msg %nick% %cmd% <username> <command> [<param>]%newline%commands: ADDMASK DELMASK NEWPASS LEVEL OPERONLY EMAIL'),

{(cmd:'REHASH';
level:900;
p:priv_rehash;
minparams:1;
info:'Reloads the config and account data from HD.';
syntax:'type /msg %nick% %cmd%'),}
(
cmd:'SAVE';
level:900;
p:priv_save;
minparams:1;
info:'Saves the config and account data to HD.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'SAVEALL';
level:900 ;
p:priv_saveall;
minparams:1;
info:'save files of all bots';
syntax:'%cmd%'),

(
cmd:'RESTART';
level:900;
p:priv_restart;
minparams:1;
info:'Restarts %nick%.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIE';
level:900;
p:priv_die;
minparams:1;
info:'terminates bewareserv.';
syntax:'type /msg %nick% %cmd%'),
(
cmd:'DIEBOT';
level:900;
p:priv_diebot;
minparams:1;
info:'Stops only %nick%.';
syntax:'type /msg %nick% %cmd%'),

(
cmd:'CHLEVEL';
level:1000;
p:priv_level;
minparams:1;
info:'Changes the access level of a command.';
syntax:'%cmd% [<command>] [<level>]'),
(
cmd:'CHCOMNAME';
level:1000;
p:priv_chcomname;
minparams:3;
info:'Changes the name of a command.';
syntax:'%cmd% <old command name> <new command name>'),
(cmd:'CHINFO';
level:1000;p:priv_chinfo;
minparams:3;
info:'Changes the info field for a command.';
syntax:'%cmd% <command> <new info setting>'),
(
cmd:'CHSYNTAX';
level:1000;
p:priv_chsyntax;
minparams:3;
info:'Changes the syntax field for a command.';
syntax:'%cmd% <command> <new syntax setting>'),

(
cmd:'SET';
level:1000;
p:priv_set;
minparams:2;
info:'view/change configuration of This bot';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:set_replace),
(
cmd:'GSET';
level:1000;
p:priv_globalset;
minparams:2;
info:'view/change configuration of the services server';
syntax:'%cmd% <option> [<new value>|none]%newline%options:%options%';
extrareplaceproc:globalset_replace),
(
cmd:'RSET';
level:1000;
p:priv_replyset;
minparams:2;
info:'view/change reply strings';
syntax:'%cmd% <reply name> [<new value>|none]'),
(
cmd:'SAY';
level:1000;
p:priv_say;
minparams:3;
info:'makes the service talk';
syntax:'%cmd% <channel|nick> <message>'),
(
cmd:'WHOAMI';
level:1;
p:priv_whoami;
minparams:1;
info:'tells you about your own account';
syntax:'%cmd%'),
(
cmd:'START';
level:1000;
p:priv_start;
minparams:2;
info:'starts a bot';
syntax:'%cmd% <botname>'),
(
cmd:'STOP';
level:1000;
p:priv_stop;
minparams:2;
info:'stops a bot';
syntax:'%cmd% <botname>'),
(
cmd:'GHOST';
level:-1;
p:priv_ghost;
minparams:3;
info:'kills a user who is logged into your account';
syntax:'%cmd% <target nick> <password>') ,
(
cmd:'LISTIPTHROTTLE';
level:100;
p:priv_listipthrottle;
minparams:1;
info:'lists ip throttle entrys';
syntax:'%cmd%'),
(
cmd:'DELIPTHROTTLE';
level:200;
p:priv_delipthrottle;
minparams:2;
info:'deletes an ip throttle entry';
syntax:'%cmd% <ip>')

);


implementation
uses
  authbot         , blinklist      , bservunit                 , bparse      ,
  bcmds           , passcryp       , bsetcommand               , btime       ,
  readtxt         , authipthrottle , authemailban              , bcrash      ,
  pgstuff         , pgdebugout     , pgmail                    , unitbanmask ,
  authbot_replies , generalreplies , accountmanagecmds_replies ;


procedure priv_nickkill(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us:tuser;
begin
 with tauthbot(botobject) do begin
  if not locopt.nickserv then begin
    send(sendtalk+reply_functiondisabled);
    exit;
  end;

  if (taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr) = nil) then begin
    send(sendtalk+reply_notloggedin);
    exit;
  end;

  us := findnick(taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(sptr).name);

  if us = nil then begin
    send(sendtalk+reply_nooneusingyournick);
    exit;
  end;

  if us = sptr then begin
    send(sendtalk+reply_usingnickyourself);
    exit;
  end;

  sendkill(us,sptr.name,killmessage_nickservkill);
  send(sendtalk+reply_nickservkill);
 end;
end;



{===================================================================== info commands}




{procedure priv_lusers(sptr:tuser;parc:integer;parv:pparams;msg:string);
begin
  send(sendtalk+'There are '+
  inttostr(count.globalclients-count.invisible)+' users and '+
  inttostr(count.invisible)+' invisible on '+
  inttostr(count.globalservers)+' servers');
  send(sendtalk+inttostr(count.globalclients)+' global users');

  send(sendtalk+inttostr(count.oper)+' operator(s) online');
  send(sendtalk+inttostr(count.channels)+' channels formed');
end;}

{========================================================================= misc}


function lastparam(parv:pparams;parc,first:integer):string;
var
  a:integer;
begin
  result := '';
  for a := first to parc-1 do begin
    if result <> '' then result := result + ' ';
    result := result +parv[a];
  end;
end;


{
onsavefile(from:tuser;,filename:string)

can be used to have multiple bots use the same file for something;
one bot saves, another bot loads

}



{=======================================================================commands management}




procedure priv_hello(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s:string;
  a:integer;
  password : string;
  mail : trequestmailsession;
  emailusername  : string;
  emaildomain    : string;
  counter        : word;
  atfound     : boolean;
  currentpartlen : word;
  longpartcount  : word;

  mailtext:string;
  fromstr:string;
  Pt:treadtext;
  sl:tstringlinklist;
begin
 with tauthbot(botobject) do begin
  if (parc < 4) or (parv[3] = '') then begin
    {if locopt.emailreg then begin
      send(sendtalk+'To create an account type /msg '+mybot.name+' '+cmd+' <an account name> <my e-mail address> <my e-mail address again> (For example /msg '+mybot.name+' memzy me@myisp.com me@myisp.com )');
    end else begin
      send(sendtalk+'To create an account
      end;
    exit}
  end;

  a := authipthrottle_find(sptr.binip,tauthbot(botobject)) + locopt.registerthrottle - unixtime;
  if a > 0 then begin
    //send(sendtalk+'You can''t register an account from your IP now. Please wait '+inttostr(a)+' seconds.');
    send(sendtalk+replacealias(reply_ipthrottledforregister,'%time%',inttostr(a)));

    exit;
  end;

  if locopt.nickserv then if not strcompup(parv[1],sptr.name) then begin
    send(sendtalk+reply_useyournickasusername);
    exit;
  end;

  s := taccountUSINGserviceunit(srvunit).accountcore.convertaccountname(parv[1]);

  if not validaccountname(parv[1]) then begin
    send(sendtalk+reply_invalidusername);
    exit
  end;

  if parv[2] <> parv[3] then begin
    if locopt.emailreg then begin
      send(sendtalk+reply_musttypeemailtwice)
    end else begin
      send(sendtalk+reply_musttypepasswordtwice);
    end;
    exit
  end;

  atfound := false;
  emailusername := '';
  emaildomain   := '';
  currentpartlen := 0;
  longpartcount  := 0;
  {moved here to prevent compiler warnings}
  if locopt.emailreg then begin
    for counter := 1 to length(parv[2]) do begin
      if not atfound then begin
        if parv[2][counter] = '@' then begin
          atfound := true;
        end else begin
          emailusername := emailusername + parv[2][counter];
        end;
      end else begin
        if parv[2][counter] = '@' then begin
          send(sendtalk+reply_morethanoneatinemail);
          exit;
        end else begin
          emaildomain := emaildomain + parv[2][counter];
          if parv[2][counter] = '.' then begin
            if currentpartlen > 3 then inc(longpartcount);
            currentpartlen := 0;
          end else begin
            inc(currentpartlen);
          end;
        end;
      end;
    end;
    if currentpartlen > 3 then inc(longpartcount);
    if not atfound then begin
      send(sendtalk+reply_noatinemail);
      exit;
    end;

    if (not validhost(emaildomain)) or (pos('.',emaildomain) = 0) then begin
      send(sendtalk+reply_invaliddomainpartofemail);
      exit;
    end;

    {check host against hosts blacklist (localhost and 127.*}
    if not isoper(sptr) then begin
      sl := emailbanlist;
      while sl <> nil do begin
        if maskmatchup(sl.s,parv[2]) then begin
          send(sendtalk+reply_emailblacklisted);
          exit;
        end;
        sl := tstringlinklist(sl.next);
      end;
    end;

  end;
  p := taccountUSINGserviceunit(srvunit).accountcore.accountlist;
  while p <> nil do begin
    if locopt.emailreg then begin
      if compareemail(parv[2],p.email,longpartcount >= 2) then begin
        // the compiler warns that longpartcound may not have been initalised this is not the case
        if longpartcount >= 2 then begin
          //send(sendtalk+'Another e-mail address ending in '+emaildomain+' is in database. Please contact an ircop.' );
          send(sendtalk+replacealias(reply_thisdomainalreadyindatabase,'%emaildomain%',emaildomain ) );

        end else begin
          send(sendtalk+parv[2]+' '+reply_alreadyindatabase )
        end;
        exit;
      end;
    end;
    (*
    -- must be different. using IP throttle list
    if copy(p.hellouser,pos(' ',p.hellouser)+1,32767)=sptr.ip then begin
      send(sendtalk+'Your IP has been used to create an account before. Please contact an ircop.');
      exit;
    end;
    *)
    p := taccount(p.next);
  end;

  a := 0;
  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);

  if p <> nil then begin
    //send(sendtalk+'account '+p.name+' already exists.');
    send(sendtalk+replacealias(reply_accountalreadyexists,'%account%',p.name));

    exit;
  end else begin
    taccountUSINGserviceunit(srvunit).accountcore.addaccount(parv[1],a);
  end;

  authipthrottle_add(sptr.binip,unixtime,tauthbot(botobject));

  p := taccountUSINGserviceunit(srvunit).accountcore.findaccount(parv[1]);
  //-------------
  assert(assigned(p),'authbot - hello - account not found after creating it','');
    {this code should never run if it does there is a major bug somewhere}
    {thats what i use asserts for - beware}

  p.addmask('*!*@*');
  if locopt.emailreg then begin
    password := randompassword;
    p.email := parv[2];
  end else begin
    password := parv[2];
  end;

  p.password := passnewcrypt(password);
  p.hellouser := sptr.name+'!'+sptr.userid+'@'+sptr.host+'['+ircipbintostr(sptr.binip)+']';

  p.lastmailts := unixtime;

  if not locopt.emailreg then begin
    send(sendtalk+reply_accountcreatedsucessfully);
    exit;
  end;
  // the rest of this procedure only runs if e-mail registration is on

  mail := trequestmailsession.create;
  // storing pointers to users and accounts is dangerous as the account could be
  // deleted by an ircop or the user who was applying for an account could go
  // offline so we store the user by P10 ID and the account by name
  mail.client := sptr.idstr ;
  mail.account := parv[1];
  mail.bot := tauthbot(botobject);
  debugout('abount to call sendmail');


  assert(readtext_init(pt,authmailfile),'failed to open auth mail text',authmailfile);
  mailtext := '';
  fromstr := p.hellouser;
  while not readtext_eof(pt) do begin
    s := readtext_line(pt);
    s := replacealias(s,'%id%',parv[1]);
    s := replacealias(s,'%pass%',password);
    s := replacealias(s,'%anick%',mybot.name);
    s := replacealias(s,'%aserver%',me.name);
    s := replacealias(s,'%fromuser%',fromstr);
    if s = '.' then s := '..';
    mailtext := mailtext + s + #13#10;
  end;
  readtext_close(pt);

  sendmail(locopt.fromemail ,locopt.fromemailrealname,parv[2],
  mailtext,
  locopt.mailserver,
  'your '+mybot.name+' account',
  mail.mailfinished);

  logaction(sptr,cmd+' '+parv[1]+' '+parv[2]);

  debugout('sendmail complete');
 end;
end;

procedure priv_requestpassword(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  p:taccount;
  s:string;
  password : string;
  mail : tnewpassmailsession;

  mailtext:string;
  fromstr:string;
  Pt:treadtext;
begin
 with tauthbot(botobject) do begin
  if not locopt.emailreg then begin
    send(sendtalk+reply_functiondisabled);
    exit
  end;

  {if (parc < 2) or (parv[1] = '') then begin
    send(sendtalk+cmd+' To request a new password /msg '+mybot.name+' requestpassword <the e-mail addy you used to register with>');
    exit
  end;}

  p := taccountUSINGserviceunit(srvunit).accountcore.accountlist;
  while p <> nil do begin

    if parv[1]=p.email then begin
      // the compiler warns that longpartcound may not have been initalised this is not the case
      break
    end;

    p := taccount(p.next);
  end;
  if p=nil then begin
    send(sendtalk+reply_emailnotindatabase);
    exit;
  end;

  if (p.lastmailts+locopt.mailthrottle) >= unixtime then begin
    //send(sendtalk+'You cannot requestpassword for this email address now. Please wait '+inttostr(p.lastmailts+locopt.mailthrottle - unixtime)+' seconds.');
    send(sendtalk+replacealias(reply_cannotrequestpassnow,'%time%',inttostr(p.lastmailts+locopt.mailthrottle - unixtime)));

    exit;
  end;
  p.lastmailts := unixtime;
  if p.level = 0 then begin
    send(sendtalk+reply_cannotrequestneverusedaccount);
    exit;
  end;
  password := randompassword;

  mail := tnewpassmailsession.create;
  // storing pointers to users and accounts is dangerous as the account could be
  // deleted by an ircop or the user who was applying for an account could go
  // offline so we store the user by P10 ID and the account by name
  mail.client := sptr.idstr ;
  mail.account := p.name;
  mail.bot := tauthbot(botobject);
{  mail.oldpass := p.password;}
  p.requestedpass := passnewcrypt(password);

  debugout('abount to call sendmail');


  assert(readtext_init(pt,requestpassmailfile),'failed to open auth mail text',requestpassmailfile);
  mailtext := '';
  fromstr := sptr.name+'!'+sptr.userid+'@'+sptr.host+'['+ircipbintostr(sptr.binip)+']';
  while not readtext_eof(pt) do begin
    s := readtext_line(pt);
    s := replacealias(s,'%id%',p.name );
    s := replacealias(s,'%pass%',password);
    s := replacealias(s,'%anick%',mybot.name);
    s := replacealias(s,'%aserver%',me.name);
    s := replacealias(s,'%fromuser%',fromstr);
    if s = '.' then s := '..';
    mailtext := mailtext + s + #13#10;
  end;
  readtext_close(pt);

  sendmail(locopt.fromemail ,locopt.fromemailrealname,parv[1],
  mailtext,
  locopt.mailserver,
  'your '+mybot.name+' account',
  mail.mailfinished);

  logaction(sptr,cmd+' '+p.name+' '+parv[1]);

  debugout('sendmail complete');
 end;
end;

procedure priv_ghost(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  us : tuser;
  ac : taccount;

  a:integer;
  //p:taccount;
  sl:tstringlinklist;
  s1,s2,s3:string;
  pp:tplinklist;
begin
  with tauthbot(botobject) do begin
    us := findname(parv[1]);
    if us=nil then begin
      send(sendtalk+reply_nosuchnick+' '+parv[1]);
      exit;
    end;
    ac := taccountUSINGserviceunit(srvunit).accountcore.getaccountfromuser(us);
    if ac=nil then begin
      send(sendtalk+reply_targetnotloggedin);
      exit;
    end;
    {if operonly: check}
    if not isoper(sptr) then if ac.operonly then begin

      send(sendtalk+reply_notircop);

      exit;
    end;

    if (ac.password = '') then begin
      send(sendtalk+reply_accountdisabled);

      exit;
    end;

    s1 := sptr.name+'!'+sptr.userid+'@'+sptr.host;
    s2 := sptr.name+'!'+sptr.userid+'@'+ircipbintostr(sptr.binip);
    sl := ac.mask;
    a := 0;
    while sl <> nil do begin
      s3 := sl.s;
      if maskmatchup(s3,s1) or maskmatchup(s3,s2) then begin
        a := 1;
        break;
      end;
      sl := tstringlinklist(sl.next);
    end;
    if a = 0 then begin
      //logaction(sptr,'Failed login to '+p.name+': mask does not match');
      //if not ismortal(sptr) then send(sendtalk+'AUTHENTICATION FAILED as '+p.name+'. Your mask does not match.');

      //logaction(sptr,replacealias(log_authfailedmaskmismatch,'%account%',p.name));
      send(sendtalk+reply_maskmismatch);


      exit;
    end;
    if taccountUSINGserviceunit(srvunit).accountcore.accountpasswordmatch(ac,parv[2]) then begin
      sendkill(us,mybot.name,killmessage_ghost);
      send(sendtalk+reply_done);
    end else begin
      send(sendtalk+reply_passwordincorrect);
    end;

  end;
end;
procedure priv_listipthrottle(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  link : tipthrottle;
begin
  with tauthbot(botobject) do begin
    link := ipthrottlelist;
    while assigned(link) do begin
      //send(sendtalk+ipbintostr(link.ip)+':'+inttostr(link.ts));
      send(sendtalk+replacealias(replacealias(replacealias(reply_ipthrottlelist,'%ip%',ipbintostr(link.ip)),'%created%',timestrshort(link.ts)),'%remain%',agostr(link.ts+locopt.registerthrottle-irctime)));
      link := tipthrottle(link.next);
    end;
  end;
end;

procedure priv_delipthrottle(sptr:tuser;parc:integer;parv:pparams;const msg:string;botobject : taccountUSINGbot;const info,syntax:string);
var
  binip : tbinip;
begin
  with tauthbot(botobject) do begin
    if ipstrtobin(parv[1],binip) then begin
      if authipthrottle_del(binip,tauthbot(botobject)) then begin
        send(sendtalk+reply_done);
      end else begin
        send(sendtalk+reply_nosuchipthrottleentry);
      end;
    end else begin
      send(sendtalk+reply_invalidip);
    end;
  end;
end;

end.
