(*
 *  beware IRC services, rpl2pasmain.pas
 *  Copyright (C) 2002-2005 Bas Steendijk and Peter Green
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit rpl2pasmain;
interface
  procedure dorpl2pas(embedded:boolean);
implementation
uses
  sysutils,
  readtxt,
  classes,
  replystuff;
procedure writedosln(var f : file;s:string);
begin
  s := s + #13#10;
  blockwrite(f,s[1],length(s));
end;



function prepstring(invalue : string):string;
var
  counter : integer;
begin
  result := '''';
  //for counter := 1 to length(invalue) do begin
  counter := 1;
  while counter <= length(invalue) do begin
    case invalue[counter] of
      '''' : begin
        result := result+'''''';
      end;
      '!' : begin
        if (stringchardef(invalue,counter+1,#0) in ['a'..'f','A'..'F','0'..'9'])and(stringchardef(invalue,counter+2,#0) in ['a'..'f','A'..'F','0'..'9'])and (stringchardef(invalue,counter+3,#0) = '!') then begin
          result := result+'''#$'+invalue[counter+1]+invalue[counter+2]+'+''';
          inc(counter,3);
        end else begin
          result := result + '!';
        end;

      end;
      else begin
        result := result + invalue[counter];
      end;
    end;
    inc(counter);
  end;
  result := result + '''';
end;

procedure dorpl2pas(embedded:boolean);
var
  tin : treadtext;
  tout : file;
  registerblock : tstringlist;
  line : string;
  name : string;
  value : string;
  counter : integer;
  filelist : tstringlist;
  searchrec : tsearchrec;
  findresult : integer;
  paramno : integer;
  basename : string;
  tempint  : integer;
  fileloopcounter : integer;
  version : string;
begin
  filelist := tstringlist.Create;

  if (paramcount=0) or embedded then begin
    findresult := FindFirst('*.rpls',0,searchrec);
    while findresult=0 do begin
      filelist.add(searchrec.name);
      findresult := findnext(searchrec);
    end;
    findclose(searchrec);
  end else begin;
    for paramno := 1 to paramcount do begin
      if (pos('*',paramstr(paramno))<>0) or (pos('?',paramstr(paramno))<>0) then begin
        findresult := FindFirst(paramstr(paramno),0,searchrec);
        while findresult=0 do begin
          filelist.add(extractfilepath(paramstr(paramno))+searchrec.name);
          findresult := findnext(searchrec);
          findclose(searchrec);
        end;
      end else begin
        filelist.add(paramstr(counter));
      end;
    end;
  end;
  for fileloopcounter := 0 to filelist.count-1 do begin
    basename := filelist[fileloopcounter];
    tempint := length(basename);
    if (upcase( basename[tempint])='S')and(upcase( basename[tempint-1])='L')and(upcase( basename[tempint-2])='P')and(upcase( basename[tempint-3])='R')and(upcase( basename[tempint-4])='.') then begin
      setlength(basename,length(basename)-5);
    end;
    registerblock := tstringlist.create;
    readtext_init(tin,basename+'.rpls');
    assign(tout,basename+'.pas');
    rewrite(tout,1);
    writedosln(tout,'//autoconverted by rpl2pas from '+ExtractFileName(basename)+'.rpls');
    writedosln(tout,'unit '+ExtractFileName(basename)+';');
    writedosln(tout,'interface');
    writedosln(tout,'var');
    repeat
      line := readtext_line(tin);
      if length(line) >=1 then begin
        if line [1] = '#' then begin
          line[1] := '/';
          writedosln(tout,'/'+line);
        end else begin
          if pos('=',line) > 0 then begin

            name := copy(line,1,pos('=',line)-1);
            if pos(':',name)=0 then begin
              version := '0';
            end else begin
              version := copy(name,pos(':',name)+1,65535);
              setlength(name,pos(':',name)-1);
            end;
            value := copy(line,pos('=',line)+1,65535);
            writedosln(tout,'  '+name+':string;');
            registerblock.Add('  addreply(@'+name+','''+name+''','+prepstring(value)+','+version+');');
          end;
        end;
      end;
    until readtext_eof(tin);
    writedosln(tout,'implementation');
    writedosln(tout,'uses replymanager;');
    writedosln(tout,'begin');
    for counter := 0 to registerblock.count-1 do begin
      writedosln(tout,registerblock[counter]);
    end;
    writedosln(tout,'end.');
    closefile(tout);
    readtext_close(tin);
    registerblock.free;
  end;
  //writeln('done');
  //readln;

end;

end.
